#-------------------------------------------------------------------#
# ManageCharboard.pl						    #
#-------------------------------------------------------------------#
# CharBoard 4 YaBB 2.3.1					    #
# Version 0.1 beta						    #
# by Carsten Dalgaard						    #
#-------------------------------------------------------------------#
# Copyright: 2009 'Carsten Dalgaard' - All Rights Reserved	    #
# Released: January 11, 2009					    #
# e-mail: carsten.dalgaard@gmail.com				    #
#-------------------------------------------------------------------#
# Any redistribution of this script without the expressed written   #
# consent of 'Carsten Dalgaard' is strictly prohibited. Copying     #
# any	of the code contained within this script and claiming it as #
# your own is also prohibited.					    #
#-------------------------------------------------------------------#
# By using this script you agree to indemnify 'Carsten Dalgaard'    #
# from any liability that might arise from its use.		    #
#-------------------------------------------------------------------#
# You may not remove any of these header notices.		    #
#-------------------------------------------------------------------#
$managecharboardplver = 'YaBB 2.3.1 $Revision: 0.1 beta $';
if ($action eq 'detailedversion') { return 1; }

LoadLanguage("charboard");

sub ManageCharboard {
my (@tmpchars, $boardname);
if($INFO{'charboard'}) {
	$selboard = "$INFO{'charboard'}";
	$boardname = "$INFO{'charboard'}";
	$boardname =~ s/\_/ /g;
}
else {
	$selboard = "new";
}
if($boardname eq "new") { $boardname = ""; }
if (-e "$vardir/characters.txt") {
	$setchselect = "";
	fopen(SPECHAR, "$vardir/characters.txt");
	%charinf = map /(.*)\t(.*)/, <SPECHAR>;
	fclose(SPECHAR);
	$setchselect = qq~<select name="charsets" id="charsets" onchange="if(this.options[this.selectedIndex].value) selectChars(this.options[this.selectedIndex].value);" style="width: 356px; font-size: 11px;">\n~;
	$setchselect .= qq~<option value="new">$chartxt{'02'}</option>\n~;
	$setchselect .= qq~<option value="">-------------------</option>\n~;
	while (($thecharset, $thechars) = each(%charinf)) {
		$thischarset = $thecharset;
		$thischarset =~ s/\_/ /g;
		$thisselected = "";
		if($thecharset eq $selboard) {
			$thisselected = qq~ selected='selected'~;
			@tmpchars = split(/\|/, $thechars);
		}
		$setchselect .= qq~<option value="$thecharset"$thisselected>$thischarset</option>\n~;
	}
	$setchselect .= qq~</select>~;
	undef %charinf;
}

$yymain .= qq~
<form action="$adminurl?action=managecharboard1" method="post" onsubmit="return CheckForm(this);">
<div class="bordercolor" style="padding: 0px; width: 560px; margin-left: auto; margin-right: auto;">
<table width="100%" cellspacing="1" cellpadding="4">
	<tr>
		<td colspan="2" align="left" class="titlebg">
		<img src="$imagesdir/preferences.gif" alt="" border="0" /><b>$chartxt{'03'}</b>
		</td>
	</tr>
	<tr>
		<td align="left" class="windowbg2" width="400">
			<div class="windowbg" name="boardcanvas" id="boardcanvas" style="position: relative; left: 8px; width: 366px; padding: 4px; border: 1px solid gray; margin: 6px; text-align: center;">
			<div name="theboard" id="theboard" style="width: 356px; height: 176px; text-align: center; border: 1px solid gray; margin-left: auto; margin-right: auto; margin-bottom: 4px;">
~;
for($i=0; $i<60; $i++) {
	my ($thischar, $thisdescript) = split(/\,/, $tmpchars[$i]);
	$thischar =~ s/^(\d{2,})$/ $1>32 ? "\&\#$1\;" : $& /egis;

$yymain .= qq~
	<div style="float: left; text-align: center; font-size: 11px; line-height: 1.8; height: 44px; width: 23px; background-image: url($modimgurl/charboard/charkey.gif); background-repeat: no-repeat;" title="">
		<input class="windowbg" type="text" value="$thischar" size="2" name="key$i" id="key$i" style="width: 11px; font-size: 11px; font-weight: normal; border: 0; margin-top: 2px; margin-bottom: 3px;" readonly="readonly" />
		<input type="hidden" value="$thisdescript" name="descript$i" id="descript$i" />
		<input class="windowbg" type="radio" name="keysel" value="$i" style="border: 0px;" onclick="addChars(this.value);" />
	</div>
~;
	if($i == 14 || $i == 44) {
		$yymain .= qq~<div style="float: left; text-align: center; height: 44px; width: 11px; background-image: url($modimgurl/charboard/halfkey.gif); background-repeat: no-repeat;">&nbsp;</div>~;
		$yymain .= qq~<div style="float: left; text-align: center; height: 44px; width: 11px; background-image: url($modimgurl/charboard/halfkey.gif); background-repeat: no-repeat;">&nbsp;</div>~;
	}
}


$yymain .= qq~
			</div>
			$setchselect
			</div>
		</td>
		<td align="left" class="windowbg2">
			<div style="width: 122px; margin-left: auto; margin-right: auto;">
			$chartxt{'04'}<br /><input type="text" size="20" name="boardname" id="boardname" value="$boardname" style="width: 120px; font-size: 11px;" /><br /><br />
			$chartxt{'05'}<br /><span class="small">$chartxt{'12'}</span><br /><input type="text" size="7" name="character" id="character" value="" style="width: 60px; font-size: 11px;" onclick="showKey(this.value);" onkeyup="showKey(this.value);" onchange="showKey(this.value);" /> &nbsp; <input class="windowbg2" type="text" value="" size="2" name="keyview" id="keyview" style="width: 16px; font-size: 16px; font-weight: normal; border: 0;" readonly="readonly" /><br /><br />
			$chartxt{'06'}<br /><input type="text" size="20" name="description" id="description" value="" style="width: 120px; font-size: 11px;" /><br /><br /><br />
			<input type="button" class="button" value="$chartxt{'07'}" style="width: 122px; font-size: 11px;" onclick="insChars();" />
			</div>
		</td>
	</tr>
	<tr>
		<td colspan="2" align="center" class="catbg">
			<input class="button" type="submit" name="addcharboard" id="addcharboard" value="$chartxt{'08'}" />
~;
			unless($selboard eq "new") {
				$yymain .= qq~<input class="button" type="submit" name="remcharboard" id="remcharboard" value="$chartxt{'09'}" onclick="return confirm('$chartxt{'11'}')" />~;
			}
$yymain .= qq~
		</td>
	</tr>
</table>
</div>
</form>

	<script language="JavaScript1.2" type="text/javascript">
	<!--
		var inskey;
		var issel = false;

		function selectChars(selset) {
			location.href="$adminurl?action=managecharboard;charboard="+selset;
		}

		function addChars(cvalue) {
			inskey = cvalue;
			issel = true;
			var str = document.getElementById('key' + cvalue).value;
			var strval = str.charCodeAt(0);
			if(strval > 32) document.getElementById('character').value = str.charCodeAt(0);
			else document.getElementById('character').value = str;
			document.getElementById('description').value = document.getElementById('descript' + cvalue).value;
			showKey(str);
		}

		function insChars() {
			if(issel) {
				var str = document.getElementById('character').value;
				str=str.replace(/\\&\\#(\\d{2,})\\;/ig, "\$1");
				if(str) {
					if(isNaN(str)) document.getElementById('key' + inskey).value = str;
					else document.getElementById('key' + inskey).value = String.fromCharCode(str);
					document.getElementById('descript' + inskey).value = document.getElementById('description').value;
				}
				else {
					document.getElementById('key' + inskey).value = '';
					document.getElementById('descript' + inskey).value = '';
				}
			}
		}

		function showKey(str) {
			str=str.replace(/\\&\\#(\\d{2,})\\;/ig, "\$1");
			if(str) {
				if(isNaN(str)) document.getElementById('keyview').value = str;
				else document.getElementById('keyview').value = String.fromCharCode(str);
			}
			else document.getElementById('keyview').value = '';
		}

		function CheckForm(theform) {
			if (theform.boardname.value == '') {
				alert("$chartxt{'10'}");
				theform.boardname.focus();
				return false;
			}
			return true;
		}

	//-->
	</script>

~;

$yytitle = $chartxt{'01'};
$action_area = "managecharboard";
&AdminTemplate;
exit;
}

sub ManageCharboard1 {
my $actcharboard = $FORM{'boardname'};
$actcharboard =~ s/ /\_/g;
if($actcharboard) {
	fopen(SPECHAR, "$vardir/characters.txt");
	%charinf = map /(.*)\t(.*)/, <SPECHAR>;
	fclose(SPECHAR);
	if($FORM{'addcharboard'}) {
		$actkey = $FORM{'key0'};
		$actkey =~ s/\&\#(\d{2,})\;/$1/g;
		$charkeys = qq~$actkey,$FORM{'descript0'}~;
		for($i=1; $i<60; $i++) {
			$actkey = $FORM{'key'.$i};
			$actkey =~ s/\&\#(\d{2,})\;/$1/g;
			$charkeys .= qq~|$actkey,$FORM{'descript'.$i}~;
		}
		$charinf{$actcharboard} = qq~$charkeys~;
		$yySetLocation = qq~$adminurl?action=managecharboard;charboard=$actcharboard~;
	}
	elsif($FORM{'remcharboard'}) {
		delete($charinf{$actcharboard});
		$yySetLocation = qq~$adminurl?action=managecharboard;charboard=new~;
	}
	fopen(SPECHAR, ">$vardir/characters.txt");
	print SPECHAR map "$_\t$charinf{$_}\n", keys %charinf;
	fclose(SPECHAR);
	undef %charinf;
}
&redirectexit;
}

1;