#-------------------------------------------------------------------#
# CharBoard.pl							    #
#-------------------------------------------------------------------#
# CharBoard 4 YaBB 2.3.1					    #
# Version 0.1 beta						    #
# by Carsten Dalgaard						    #
#-------------------------------------------------------------------#
# Copyright: 2009 'Carsten Dalgaard' - All Rights Reserved	    #
# Released: January 11, 2009					    #
# e-mail: carsten.dalgaard@gmail.com				    #
#-------------------------------------------------------------------#
# Any redistribution of this script without the expressed written   #
# consent of 'Carsten Dalgaard' is strictly prohibited. Copying     #
# any	of the code contained within this script and claiming it as #
# your own is also prohibited.					    #
#-------------------------------------------------------------------#
# By using this script you agree to indemnify 'Carsten Dalgaard'    #
# from any liability that might arise from its use.		    #
#-------------------------------------------------------------------#
# You may not remove any of these header notices.		    #
#-------------------------------------------------------------------#
$charboardplver = 'YaBB 2.3.1 $Revision: 0.1 beta $';
if ($action eq 'detailedversion') { return 1; }

LoadLanguage("charboard");

sub charBoard {
$charmain = "";

if (-e "$vardir/characters.txt") {
	$setchselect = "";
	$setchoptions = "";
	$setcnt = 0;
	fopen(SPECHAR, "$vardir/characters.txt");
	%charinf = map /(.*)\t(.*)/, <SPECHAR>;
	fclose(SPECHAR);
	$setchselect = qq~<select name="charsets" id="charsets" onchange="if(this.options[this.selectedIndex].value) selectChars(this.options[this.selectedIndex].value);" style="width: 356px; font-size: 11px;">\n~;
	while (($thecharset, $thechars) = each(%charinf)) {
		$optcnt = 0;
		$setcnt++;
		$thischarset = $thecharset;
		$thischarset =~ s/\_/ /g;
		@tmpchars = split(/\|/, $thechars);
		if($setcnt == 1) {
			$setchselect .= qq~<option value="none"></option>\n~;
		}
		$setchselect .= qq~<option value="$thecharset">$thischarset</option>\n~;
		$setchoptions .= qq~<div name="$thecharset" id="$thecharset" style="display: none;">~;
		foreach $specchar (@tmpchars) {
			$optcnt++;
			my ($thischar, $thisdescript) = split(/\,/, $specchar);
			$thischar =~ s/^(\d{2,})$/ $1>32 ? "\&\#$1\;" : $& /egis;
			if($thischar) {
				$setchoptions .= qq~<div style="float: left; text-align: center; font-size: 11px; line-height: 1.6; height: 22px; width: 23px; cursor: pointer; background-image: url($modimgurl/charboard/charkey.gif);" title="$thisdescript" onclick="AddText('$thischar');">$thischar</div>~;
			}
			else {
				$setchoptions .= qq~<div style="float: left; text-align: center; height: 22px; width: 23px; background-image: url($modimgurl/charboard/charkey.gif);">&nbsp;</div>~;
			}
			if($optcnt == 15 || $optcnt == 45) {
				$setchoptions .= qq~<div style="float: left; text-align: center; height: 22px; width: 11px; background-image: url($modimgurl/charboard/halfkey.gif);">&nbsp;</div>~;
				$setchoptions .= qq~<div style="float: left; text-align: center; height: 22px; width: 11px; background-image: url($modimgurl/charboard/halfkey.gif);">&nbsp;</div>~;
			}
		}
		$setchoptions .= qq~</div>~;
	}
	$setchselect .= qq~</select>~;
	undef %charinf;

	$charmain .= qq~
	<tr>
	~;
	if($action eq "imsend") {
		$charmain .= qq~
		<td align="left" valign="middle" class="windowbg2">
			<b>$chartxt{'01'}:</b><br />
		~;
	}
	else {
		$charmain .= qq~
		<td valign="middle" class="windowbg2" width="23%"><b>$chartxt{'01'}:</b></td>
		<td align="left" valign="middle" class="windowbg2" width="77%">
		~;
	}
	$charmain .= qq~
			<div class="windowbg" name="boardcanvas" id="boardcanvas" style="position: relative; left: 26px; width: 366px; padding: 4px; border: 1px solid gray; margin: 6px; text-align: center;">
			<div name="theboard" id="theboard" style="width: 356px; height: 88px; text-align: center; border: 1px solid gray; margin-left: auto; margin-right: auto; margin-bottom: 4px; display: none;">
			$setchoptions
			</div>
			$setchselect
			</div>
		</td>
	</tr>

	<script language="JavaScript1.2" type="text/javascript">
	<!--
		function selectChars(selset) {
			document.getElementById('theboard').style.display = 'block';
			for(var x = 1; x < document.getElementById('charsets').options.length; x++) {
				var tmpcharset = document.getElementById('charsets').options[x].value;
				document.getElementById(tmpcharset).style.display = 'none';
			}
			if(selset != 'none') document.getElementById(selset).style.display = 'inline';
			else {
				document.getElementById('theboard').style.display = 'none';
				document.getElementById('charsets').options[0].selected = true;
			}
		}
	//-->
	</script>
	~;
}

return $charmain;
}

1;